<?php

namespace Tablesome\Includes\Modules\TablesomeDB;

if (!defined('ABSPATH')) {
    exit;
} // Exit if accessed directly

if (!class_exists('\Tablesome\Includes\Modules\TablesomeDB\Berlin_Db_Adapter')) {
    class Berlin_Db_Adapter
    {

        public function load()
        {
            /**
             * REQUIRE BERLINDB FILES.
             * For now, BerlinDB files are manually required.
             */
            require_once TABLESOME_PATH . 'includes/lib/berlin-db/core/base.php';
            require_once TABLESOME_PATH . 'includes/lib/berlin-db/core/column.php';
            require_once TABLESOME_PATH . 'includes/lib/berlin-db/core/meta.php';
            require_once TABLESOME_PATH . 'includes/lib/berlin-db/core/compare.php';
            require_once TABLESOME_PATH . 'includes/lib/berlin-db/core/date.php';
            require_once TABLESOME_PATH . 'includes/lib/berlin-db/core/query.php';
            require_once TABLESOME_PATH . 'includes/lib/berlin-db/core/row.php';
            require_once TABLESOME_PATH . 'includes/lib/berlin-db/core/schema.php';
            require_once TABLESOME_PATH . 'includes/lib/berlin-db/core/table.php';

            // Books Table. This specifies the table name, manages table version and upgrade routines, and builds the table.
            require_once TABLESOME_PATH . 'includes/lib/berlin-db/class-books-table.php';
            // Books Schema. This specifies how the table can be queried, and what columns are in the table.
            require_once TABLESOME_PATH . 'includes/lib/berlin-db/class-books-schema.php';
            // Book Row Instance. When queried, each record that is retrieved is returned as an instance of this class.
            // BerlinDB refers to this as "shaping"
            require_once TABLESOME_PATH . 'includes/lib/berlin-db/class-book.php';
            // Book Query. This is the class you call to interact with the database class. Sort-of like an advanced WP_Query.
            require_once TABLESOME_PATH . 'includes/lib/berlin-db/class-book-query.php';
        }

    }
}
